/**
 * @file ProductionOrderGenerator.cpp
 * @author The ARTIS Development Team
 * See the AUTHORS or Authors.txt file
 */

/*
 * ARTIS - the multimodeling and simulation environment
 * This file is a part of the ARTIS environment
 *
 * Copyright (C) 2013-2023 ULCO http://www.univ-littoral.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "ProductionOrderGenerator.hpp"

namespace artis::factory {

void ProductionOrderGenerator::dint(const Time & /* &t */) {
  switch (_phase) {
    case Phase::INIT:
      _phase = Phase::SEND;
      break;
    case Phase::SEND: {
      _current_id++;
      _po_counter++;
      _productID = _productIDs[_distrib_product(_rng)];
      _po = std::make_unique<ProductionOrder>(_current_id, _productID, _parameters.programs[_productID]);
      _send_speed = _distrib_send_speed(_rng);
      _phase = Phase::SEND;
      break;
    }
  }
}

void ProductionOrderGenerator::dext(const Time & /* t */, const Time & /* e */, const Bag &bag) {
  std::for_each(bag.begin(), bag.end(), [](const ExternalEvent & /* event */) {
    assert(false);
  });
}

void ProductionOrderGenerator::start(const Time & /* t */) {
  _phase = Phase::INIT;
  _po = nullptr;
  _current_id = 0;
  _productID = _productIDs[_distrib_product(_rng)];
  _po = std::make_unique<ProductionOrder>(_current_id, _productID, _parameters.programs[_productID]);
  _po_counter = 0;
  _send_speed = 0; // _distrib_send_speed(_rng);
}

Time ProductionOrderGenerator::ta(const Time & /* t */) const {
  switch (_phase) {
    case Phase::INIT:
      return 0;
    case Phase::SEND:
      return _send_speed;
  }
  return artis::common::DoubleTime::infinity;
}

Bag ProductionOrderGenerator::lambda(const Time & /* t */) const {
  Bag bag;

  if (_phase == Phase::SEND) {
    if (_po) {
      bag.push_back(ExternalEvent(outputs::OUT, common::event::Value(_po->_buffer, _po->_size)));
    }
  }
  return bag;
}

artis::common::event::Value ProductionOrderGenerator::observe(const Time & /* t */, unsigned int index) const {
  switch (index) {
    case vars::TOTAL_PO_NUMBER:
      return (unsigned int) _po_counter;
  }
  return {};
}

} // namespace artis::factory
